/* 
 * $RCSfile: part.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 *
 * $Log: part.h,v $
 * Revision 1.15.1.4  1995/08/04 00:00:26  ho
 * Added SPI part def for security work.
 *
 * Revision 1.15.1.3  1994/09/13  05:44:56  gkim
 * added ANY_HIGH_PORT
 *
 * Revision 1.15.1.2  1994/06/10  22:58:00  ho
 * Added ANY_LOW_PORT.
 *
 * Revision 1.15.1.1  1994/06/04  01:42:18  menze
 * Added parens in partLen macro
 *
 */

#ifndef part_h
#define part_h

#ifndef xtype_h
#include "xtype.h"
#endif

/* 
 * Participant library
 */

/********************  private/opaque declarations ****************/

#define	PART_MAX_STACK	20

typedef struct {
    struct {
	VOID	*ptr;
	int	len;
    } arr[PART_MAX_STACK];
    int		top;
} PartStack;

typedef struct {
    int		len;
    PartStack	stack;	/* A stack of void* pointers */
} Part;

#ifdef __STDC__

void	partStackPush( PartStack *s, void *data, int );
void *	partStackPop( PartStack *s );

#else

void		partStackPush();
VOID		*partStackPop();

#endif /* __STDC__ */

/********************  public declarations ****************/

#define SPI_PART    2
#define LOCAL_PART  1
#define REMOTE_PART 0

/* 
 * Initialize a vector of N participants
 */
#ifdef __STDC__
void	partInit( Part *p, int N );
#endif

/* 
 * push 'data' onto the stack of participant 'p'.  
 */
#define partPush( p, data, len ) partStackPush( &(p).stack, data, len );

/* 
 * pop off and return the top element of p's stack.  return NULL if
 * there are no more elements
 */
#define partPop( p ) partStackPop( &(p).stack )

#define partLen( partPtr ) ((partPtr)->len)

xkern_return_t	partExternalize(
#ifdef __STDC__
				Part *, VOID *, int *
#endif
				);

void partInternalize(
#ifdef __STDC__
				Part *, VOID *
#endif
				);

#define partExtLen( _bufPtr )	( *(int *)(_bufPtr) )

int partStackTopByteLen(
#ifdef __STDC__
			Part
#endif
			);


#define ANY_HOST	((VOID *) -1)
#define ANY_PORT	-1
#define ANY_LOW_PORT	-2
#define ANY_HIGH_PORT	-3

#endif /* part_h */
