/**********************************************************/
/* Mach3: This is an altered version of udp_hdr.c         */
/*        to be used when building an in-kernel version   */
/*        of the x-kernel. That is due to the fact that   */
/*        up to now usc/usit produce strict ANSI C code   */
/*        while in-kernel code is compiled with a K&R cc. */
/*        It works for mach3-mips and mach3-intelx86.     */
/*                                                        */
/* This should be fixed in the next usc/usit release.     */
/*                                                        */
/* Based on the files listed below as USC/USIT input      */
/**********************************************************/

/**********************************************************/
/*                                                        */
/*                  USC Output                            */
/*                  Wed Nov 16 16:03:24 1994              */
/*                  File: udp_hdr.usc                     */
/*                                                        */
/**********************************************************/

/**********************************************************/
/*                                                        */
/*                  USIT Output                           */
/*                  Wed Nov 16 16:02:37 1994              */
/*                  File: udp_hdr.usit                    */
/*                                                        */
/**********************************************************/
/*
 * $RCSfile: udp_hdr.c,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 * usc/usit v1.0
 *
 * Copyright (c) 1994  Arizona Board of Regents
 *
 * $Revision: 1.1 $
 * $Date: 1994/11/23 16:52:07 $
 *
 */
#include "xkernel.h"
#include "ip.h"
#include "udp.h"
#include "udp_internal.h"
#include "udp_hdr.h"
#include "gc.h"

#if defined(__STDC__) || defined(__GNUC__)
static void dispPseudoHdr( IPpseudoHdr * );
#else
static void dispPseudoHdr();
#endif

void
udpHdrCopyIn(l_native_header, l_net_header)  
  void* l_native_header;
  void* l_net_header;
{
  unsigned long r0;
  r0 = *(unsigned int *)((unsigned char *)l_net_header + (0));
  *((short *)((char *)l_native_header + (0))) =
      (((r0 >> 8) & 0xffL) |
    ((r0 << 8) & 0xff00L));
  *((short *)((char *)l_native_header + (2))) =
      (((r0 >> 24) & 0xffL) |
    ((r0 >> 8) & 0xff00L));
  r0 = *(unsigned int *)((unsigned char *)l_net_header + (4));
  *((short *)((char *)l_native_header + (4))) =
      (((r0 >> 8) & 0xffL) |
    ((r0 << 8) & 0xff00L));
  *((short *)((char *)l_native_header + (6))) =
      (((r0 >> 24) & 0xffL) |
    ((r0 >> 8) & 0xff00L));
}


void
udpHdrCopyOut( l_net_header, l_native_header)  
  void* l_net_header;
  void* l_native_header;
{
  unsigned long r0;
  unsigned long r1;
  r0 = *(unsigned short *)((unsigned char *)l_native_header + (0));
  r1 = *(unsigned short *)((unsigned char *)l_native_header + (2));
  *((int *)((char *)l_net_header + (0))) =
      (((r0 >> 8) & 0xffL) |
    ((r0 << 8) & 0xff00L) |
    ((r1 << 8) & 0xff0000L) |
    ((r1 << 24) & 0xff000000L));
  r0 = *(unsigned short *)((unsigned char *)l_native_header + (4));
  r1 = *(unsigned short *)((unsigned char *)l_native_header + (6));
  *((int *)((char *)l_net_header + (4))) =
      (((r0 >> 8) & 0xffL) |
    ((r0 << 8) & 0xff00L) |
    ((r1 << 8) & 0xff0000L) |
    ((r1 << 24) & 0xff000000L));
}


void
udpHdrCopyUOut(l_net_header, l_native_header)  
  void* l_net_header;
  void* l_native_header;
{
  unsigned long r0;
  r0 = *(unsigned short *)((unsigned char *)l_native_header + (0));
  *((char *)((char *)l_net_header + (0))) =
      ((r0 >> 8));
  *((char *)((char *)l_net_header + (1))) =
      (r0);
  r0 = *(unsigned short *)((unsigned char *)l_native_header + (2));
  *((char *)((char *)l_net_header + (2))) =
      ((r0 >> 8));
  *((char *)((char *)l_net_header + (3))) =
      (r0);
  r0 = *(unsigned short *)((unsigned char *)l_native_header + (4));
  *((char *)((char *)l_net_header + (4))) =
      ((r0 >> 8));
  *((char *)((char *)l_net_header + (5))) =
      (r0);
  r0 = *(unsigned short *)((unsigned char *)l_native_header + (6));
  *((char *)((char *)l_net_header + (6))) =
      ((r0 >> 8));
  *((char *)((char *)l_net_header + (7))) =
      (r0);
}


void
udpHdrCopyUIn( l_native_header, l_net_header)  
  void* l_native_header;
  void* l_net_header;
{
  unsigned long r0;
  unsigned long r1;
  r0 = *(unsigned char *)((unsigned char *)l_net_header + (1));
  r1 = *(unsigned char *)((unsigned char *)l_net_header + (0));
  *((short *)((char *)l_native_header + (0))) =
      ((r0 & 0xffL) |
    ((r1 << 8) & 0xff00L));
  r0 = *(unsigned char *)((unsigned char *)l_net_header + (3));
  r1 = *(unsigned char *)((unsigned char *)l_net_header + (2));
  *((short *)((char *)l_native_header + (2))) =
      ((r0 & 0xffL) |
    ((r1 << 8) & 0xff00L));
  r0 = *(unsigned char *)((unsigned char *)l_net_header + (5));
  r1 = *(unsigned char *)((unsigned char *)l_net_header + (4));
  *((short *)((char *)l_native_header + (4))) =
      ((r0 & 0xffL) |
    ((r1 << 8) & 0xff00L));
  r0 = *(unsigned char *)((unsigned char *)l_net_header + (7));
  r1 = *(unsigned char *)((unsigned char *)l_net_header + (6));
  *((short *)((char *)l_native_header + (6))) =
      ((r0 & 0xffL) |
    ((r1 << 8) & 0xff00L));
}






/*
 * udpHdrStore -- write header to potentially unaligned msg buffer.
 * Note:  in the original function (pre-usc) *hdr would be modified.
 */
void
udpHdrStore(hdr, dst, len, arg)
    VOID *hdr;
    char *dst;
    long int len;
    VOID *arg;
{
    SSTATE *sstate;
    
    xAssert(len == sizeof(HDR));
    xAssert(arg);

    ((HDR *)hdr)->sum = 0;
    if (( ((int)dst) % 4 ) == 0 )
      udpHdrCopyOut( dst, (char*)hdr );
    else
      udpHdrCopyUOut( dst, (char*)hdr );
    
    sstate = (SSTATE *)((storeInfo *)arg)->s->state;
    if (sstate->useCkSum) {
	u_short sum = 0;
	
	xTrace0(udpp, TR_FUNCTIONAL_TRACE, "Using UDP checksum");
	peekNetUdpLen( (char*)dst, (char*)&(sstate->pHdr.len) );
	xIfTrace(udpp, TR_FUNCTIONAL_TRACE) {
	    dispPseudoHdr(&sstate->pHdr);
	}
	sum = inCkSum(((storeInfo *)arg)->m, (u_short *)&sstate->pHdr,
		       sizeof(IPpseudoHdr));
	pokeNetUdpCksum( (char *)dst, (char*)&sum );
	xAssert(! inCkSum(((storeInfo *)arg)->m, (u_short *)&sstate->pHdr,
			  sizeof(IPpseudoHdr)));
    }
}


/*
 * udpHdrLoad -- load header from potentially unaligned msg buffer.
 * Result of checksum calculation will be in hdr->sum.
 */
long
udpHdrLoad(hdr, src, len, arg)
    VOID *hdr;
    char *src;
    long int len;
    VOID *arg;
{
  xAssert(len == sizeof(HDR));
  /*
   * 0 in the checksum field indicates checksum disabled
   */
  if (( ((int)src) % 4 ) == 0 )
    udpHdrCopyIn( (char*)hdr, (char *)src );
  else
    udpHdrCopyUIn( (char*)hdr, (char *)src );

  if (((HDR *)hdr)->sum) {
    IPpseudoHdr *pHdr = (IPpseudoHdr *)msgGetAttr((Msg *)arg, 0);

    xTrace0(udpp, TR_FUNCTIONAL_TRACE, "UDP header checksum was used");
    xAssert(pHdr);
    xIfTrace(udpp, TR_FUNCTIONAL_TRACE) {
      dispPseudoHdr(pHdr);
    }
    ((HDR *)hdr)->sum = inCkSum((Msg *)arg, (u_short *)pHdr, sizeof(*pHdr));
  } else {
    xTrace0(udpp, TR_FUNCTIONAL_TRACE, "No UDP header checksum was used");
  }
  return sizeof(HDR);
}

static void
dispPseudoHdr(h)
    IPpseudoHdr *h;
{
    xTrace2(udpp, TR_ALWAYS, "   IP pseudo header: src: %s  dst: %s",
	    ipHostStr(&h->src), ipHostStr(&h->dst));
    xTrace3(udpp, TR_ALWAYS, "      z:  %d  p: %d len: %d",
	    h->zero, h->prot, ntohs(h->len));
}

ERROR
