#ifndef dheckx_i_h
#define dheckx_i_h

#include "process.h"  /* semaphore stuff */
#include "event.h"    /* timeout event */

#ifdef ALPHA
#define DEGW 3
#define FIVE(a,b,c,d,e)  { (a)|(((unsigned long)(b))<<32), (c)|(((unsigned long)d)<<32), e }
#else
#define DEGW 5
#define FIVE(a,b,c,d,e)  { a,b,c,d,e }
#endif

void DheckxKnown(unsigned long *,unsigned long *, unsigned long *);
void Dheckx(unsigned long *,unsigned long *, unsigned long *,
		unsigned long *, unsigned long *);

#define TRANSPORT_PROTOCOL 0
#define KEY_MGR_PROTOCOL 1
#define KEY_MGR_SESS_IN 2
#define KEY_MGR_SESS_OUT 1
#define KEY_MGR_SESS_ALL 1  /* Used with ALL_PARTS. */

#define ALL_PARTS     	  4
/* A protocol flag bit.  If ALL_PARTS, both remote and local participants
   are used to select one key manager session.  Otherwise, a separate
   session is opened for each participant, and the keys are made identical.
   Rom option, default is OFF. */

#define DHECKX_TIMEOUT 20 /* seconds; rom option */

typedef long 	DHECKXhdr;
typedef long 	DHECKXtype;
typedef XObj  	PassiveId;
typedef XObj	ActiveId;

/* session states for DHECKX protocol  $$change to enum?? */
#define DHECKXNEW 1
#define DHECKXINIT 2
#define DHECKXINITWAIT 3
#define DHECKXCOMPUTING 4
#define DHECKXRESPONDER 5
#define DHECKXREPLYING 6
#define DHECKXTRANSPARENT 7

/* magic number for DHECKX startup message */
#define DHECKXMAGIC 314159265

typedef struct {
    Part	p[2];
    long	state;  /* DHECKXNEW, ..., DHECKXTRANSPARENT */
    XTime	starttime, endtime, deltatime, endtime2, deltatime2;
    Semaphore	semaphore;
    Event	event;
    unsigned long	k[DEGW],kpx[DEGW],kpy[DEGW],jpx[DEGW],jpy[DEGW];
} SState;    /* session state */


typedef struct {
    Map		actMap;
    Map 	pasMap;
    int		delay;   /* max time for initiator to wait for reply
			    rom option; default DHECKX_TIMEOUT (= 20) seconds */
    int		flags;   /* only ALL_PARTS (= 4) is defined; rom option */
    int		ownhlptype; /* use "self" in xOpen */
} PState;    /* protocol state */


#define	DHECKX_ACTIVE_MAP_SZ	32
#define	DHECKX_PASSIVE_MAP_SZ	16

#endif

