/*
 * @COPYRIGHT@
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 * @COPYRIGHT@
 *
 * $RCSfile: lance_desc.h,v $
 *
 * HISTORY
 * $Log: lance_desc.h,v $
 * Revision 1.1  1994/10/26 19:29:13  hkaram
 * Initial revision
 *
*/

#ifndef lance_desc_h
#define lance_desc_h

#ifdef __LANGUAGE_USC__
# define u_short unsigned short
# define u_char unsigned char
# define A(a)		a
#else
# define A(a)
#endif

/*
 * Buffer Descriptors
 * Legend:
 *	H-set-by-Host	C-set-by-chip
 */
typedef struct {
    u_short addr_low		A((2, 2, 0, <0,1>));
    u_char  addr_hi		A((1, 1, 4, <0>));
    u_char  status		A((1, 1, 5, <0>));
    u_short buffer_size		A((2, 2, 8, <0,1>));
    union {
	struct {
	    u_short bcnt	A((2, 2, 0, <0,1>));
	} rx			A((0, 2, 0, 0));
	struct {
	    u_short TDR A((2, 2, 0, <0,1>))  : 10 A((10,16,0,<0..9>));
	    u_short status A((1, 1, 1, <0>)) :  6 A((6,8,0,<2..7>));
	} tx			A((0, 2, 0, 0));
	u_short bits		A((2, 2, 0, <0,1>));
    } u				A((0, 2, 12, 0));
} LANCE_Descriptor		A((0, 16, 2, 0));

#endif /* lance_desc_h */
