/*
 * $RCSfile: buffer.h,v $
 *
 * Universal Stub Compiler
 *
 * Copyright (c) 1994    Arizona Board of Regents
 *
 * $Log: buffer.h,v $
 * Revision 1.1  1994/10/13 17:43:30  dorgival
 * Initial revision
 *
 */

#ifndef INBUFFERH
#define INBUFFERH

typedef struct {
  char *s;
  int size;
  int length;
} Buffer;


#define BUFFER_STRING(a)    ((a)->s)
#define BUFFER_SIZE(a)      ((a)->size)
#define BUFFER_LEN(a)       ((a)->length)

#ifndef FUNCHEADERBUFFER
#define FUNCHEADERBUFFER 1024
#endif

#ifndef FUNCBODYBUFFER
#define FUNCBODYBUFFER   1024
#endif

#ifndef FUNCVARBUFFER
#define FUNCVARBUFFER    32
#endif

#ifndef VAR_ARRAY_BUFFER
#define VAR_ARRAY_BUFFER 16
#endif

extern Buffer *SourceText;

extern void writebuf (Buffer *buffer, char *fmt, ...);
extern Buffer *makebuf (int size);
extern void cleanbuf (Buffer *buffer);
extern void freebuf (Buffer *buf);
extern Buffer *copy_buf (Buffer *buffer);
extern void catbuf (Buffer *one, Buffer *two);
extern void print_source (void);
extern void dump_source (void);

#endif
