/*
 * $RCSfile: preprocess.c,v $
 *
 * Universal Stub Compiler
 *
 * Copyright (c) 1994    Arizona Board of Regents
 *
 * $Log: preprocess.c,v $
 * Revision 1.1  1994/10/13 17:43:30  dorgival
 * Initial revision
 *
 */

/*
 * pragma handling routines
 */

#include "usc.h"
#include "preprocess.h"
#include "gen_utils.h"
#include "symbol.h"

void cpp_line_command (Constant *line, Constant *file)
{
  dprintf (100, "file: %s line: %ld\n", CONST_STRING (file), CONST_INT(line));
}

void cpp_pragma_command (Type *spec, Type *type_data)
{
  TypeData *data = TYPE_DECL_TYPEDATA(type_data);
  int *size = NULL;
  int *memsize = NULL;
  int *align = NULL;
  ByteOrder *border = NULL;

  switch (TYPE_SPEC_TYPE (spec)) {
  case CHAR_TYPE:
    size = &machine_info.char_info.size;
    memsize = &machine_info.char_info.memsize;
    align = &machine_info.char_info.alignment;
    border = &machine_info.char_info.byteorder;
    break;

  case SHORT_TYPE:
    size = &machine_info.short_info.size;
    memsize = &machine_info.short_info.memsize;
    align = &machine_info.short_info.alignment;
    border = &machine_info.short_info.byteorder;
    break;
    
  case INT_TYPE:
    size = &machine_info.int_info.size;
    memsize = &machine_info.int_info.memsize;
    align = &machine_info.int_info.alignment;
    border = &machine_info.int_info.byteorder;
    break;

  case LONG_TYPE:
    size = &machine_info.long_info.size;
    memsize = &machine_info.long_info.memsize;
    align = &machine_info.long_info.alignment;
    border = &machine_info.long_info.byteorder;
    break;

  default:
    crash ("internal error in cpp_pragma_command");
    break;
  }
  dprintf (100, "Type Modifier:\n");
  dexec (100, print_type_modifier ("", "", data));
  if (TYPEDATA_SIZE(data) != DEFAULT_SIZE)
    *size = TYPEDATA_SIZE (data);
  if (TYPEDATA_MEMSIZE(data) != DEFAULT_SIZE)
    *memsize = TYPEDATA_MEMSIZE (data);
  if (TYPEDATA_ALIGN(data) != DEFAULT_ALIGN)
    *align = TYPEDATA_ALIGN (data);
  if (TYPEDATA_BORDER(data) != DEFAULT_BORDER)
    *border = TYPEDATA_BORDER(data);
  if (TYPEDATA_OFFSET(data) != DEFAULT_OFFSET)
    warning ("Can't give offset information in pragma");
  if (machine_info.reg_size < 8*(*size) ) {
    machine_info.reg_size = 8*(*size);
    dprintf (10,"Assuming register size as %d bits based on default types\n",
	     machine_info.reg_size );
  }
}
